Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Class ComplexContentOutputter

    java.lang.Object
      net.sf.saxon.event.SequenceReceiver
          net.sf.saxon.event.ComplexContentOutputter

All Implemented Interfaces:
  Result, Receiver

    public final class ComplexContentOutputter

extends SequenceReceiver

This class is used for generating complex content, that is, the content of an element or document node. It enforces the rules on the order of events within complex content (attributes and namespaces must come first), and it implements part of the namespace fixup rules, in particular, it ensures that there is a namespace node for the namespace used in the element name and in each attribute name.

The same ComplexContentOutputter may be used for generating an entire XML document; it is not necessary to create a new outputter for each element node.

Author:
  Michael H. Kay

Field Summary

Fields inherited from class net.sf.saxon.event.SequenceReceiver
`pipelineConfiguration, previousAtomic, systemId`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`ComplexContentOutputter(PipelineConfiguration pipe)` Create a ComplexContentOutputter

Method Summary
`void` | `append(Item item, int locationId, int copyNamespaces)` Append an arbitrary item (node or atomic value) to the output
`void` | `attribute(NodeName attName, SimpleType typeCode, CharSequence value, int locationId, int properties)` Output an attribute value.
`void` | `characters(CharSequence s, int locationId, int properties)` Produce text content output.
`void` | `close()` Close the output
`void` | `comment(CharSequence comment, int locationId, int properties)` Write a comment
`boolean` | `contentHasBeenWritten()` Test whether any content has been written to this ComplexContentOutputter
`void` | `endDocument()` Notify the end of a document node
`void` | `endElement()` Output an element end tag.
`void` | `namespace(NamespaceBinding nsBinding, int properties)` Output a namespace declaration.
`void` | `open()` Start the output process
`void` | `processingInstruction(String target, CharSequence data, int locationId, int properties)` Write a processing instruction
`void` | `setHostLanguage(int language)` Set the host language
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipeline configuration
`void` | `setReceiver(Receiver receiver)` Set the receiver (to handle the next stage in the pipeline) directly
`void` | `startContent()` Flush out a pending start tag
`void` | `startDocument(int properties)` Start of a document node.
`void` | `startElement(NodeName elemName, SchemaType typeCode, int locationId, int properties)` Output an element start tag.
`boolean` | `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

Methods inherited from class net.sf.saxon.event.SequenceReceiver
`append, getConfiguration, getNamePool, getPipelineConfiguration, getSystemId, setSystemId, setUnparsedEntity`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ComplexContentOutputter

    public ComplexContentOutputter(PipelineConfiguration pipe)

  Create a ComplexContentOutputter

  Parameters:
    `pipe` - the pipeline configuration

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Description copied from interface: `Receiver`
  Set the pipeline configuration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Overrides:
    `setPipelineConfiguration` in class `SequenceReceiver`
  Parameters:
    `pipe` - the pipeline configuration

### setHostLanguage

    public void setHostLanguage(int language)

  Set the host language

  Parameters:
    `language` - the host language, for example `Configuration.XQUERY`

### setReceiver

    public void setReceiver(Receiver receiver)

  Set the receiver (to handle the next stage in the pipeline) directly

  Parameters:
    `receiver` - the receiver to handle the next stage in the pipeline

### contentHasBeenWritten

    public boolean contentHasBeenWritten()

  Test whether any content has been written to this ComplexContentOutputter

  Returns:
    true if content has been written

### open

    public void open()
              throws XPathException

  Start the output process

  Specified by:
    `open` in interface `Receiver`
  Overrides:
    `open` in class `SequenceReceiver`
  Throws:
    `XPathException` - if an error occurs

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Throws:
    `XPathException` - if an error occurs

### characters

    public void characters(CharSequence s,
                           int locationId,
                           int properties)
                    throws XPathException

  Produce text content output.
  Special characters are escaped using XML/HTML conventions if the output format requires it.

  Parameters:
    `s` - The String to be output
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException` - for any failure

### startElement

    public void startElement(NodeName elemName,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Output an element start tag.
  The actual output of the tag is deferred until all attributes have been output using attribute().

  Parameters:
    `elemName` - The element name
    `typeCode` - the type annotation of the element.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding nsBinding,
                          int properties)
                   throws XPathException

  Output a namespace declaration.
  This is added to a list of pending namespaces for the current start tag. If there is already another declaration of the same prefix, this one is ignored, unless the REJECT_DUPLICATES flag is set, in which case this is an error. Note that unlike SAX2 startPrefixMapping(), this call is made AFTER writing the start tag.

  Parameters:
    `nsBinding` - The namespace binding
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
  Throws:
    `XPathException` - if there is no start tag to write to (created using writeStartTag), or if character content has been written since the start tag was written.

### attribute

    public void attribute(NodeName attName,
                          SimpleType typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Output an attribute value.
  This is added to a list of pending attributes for the current start tag, overwriting any previous attribute with the same name.
  This method should NOT be used to output namespace declarations.

  Parameters:
    `attName` - The name of the attribute
    `value` - The value of the attribute
    `properties` - Bit fields containing properties of the attribute to be written
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
  Throws:
    `XPathException` - if there is no start tag to write to (created using writeStartTag), or if character content has been written since the start tag was written.

### endElement

    public void endElement()
                    throws XPathException

  Output an element end tag.

  Throws:
    `XPathException` - if an error occurs

### comment

    public void comment(CharSequence comment,
                        int locationId,
                        int properties)
                 throws XPathException

  Write a comment

  Parameters:
    `comment` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `XPathException` - if an error occurs

### processingInstruction

    public void processingInstruction(String target,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Write a processing instruction

  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.
  Throws:
    `XPathException` - if an error occurs

### append

    public void append(Item item,
                       int locationId,
                       int copyNamespaces)
                throws XPathException

  Append an arbitrary item (node or atomic value) to the output

  Specified by:
    `append` in class `SequenceReceiver`
  Parameters:
    `item` - the item to be appended
    `locationId` - the location of the calling instruction, for diagnostics
    `copyNamespaces` - if the item is an element node, this indicates whether its namespaces need to be copied. Values are `NodeInfo.ALL_NAMESPACES`, `NodeInfo.LOCAL_NAMESPACES`, `NodeInfo.NO_NAMESPACES`
  Throws:
    `XPathException` - if the operation fails

### close

    public void close()
               throws XPathException

  Close the output

  Throws:
    `XPathException` - if an error occurs

### startContent

    public void startContent()
                      throws XPathException

  Flush out a pending start tag

  Throws:
    `XPathException` - if an error occurs

### usesTypeAnnotations

    public boolean usesTypeAnnotations()

  Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

  Returns:
    true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.